﻿using System;
using System.Threading;
using System.Windows.Forms;

namespace WindowsFormsApplication1
{
    public partial class Form2 : Form
    {
        public Form2()
        {
            InitializeComponent();
            //方法一：不进行跨线程安全检查  
            CheckForIllegalCrossThreadCalls = false;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Thread th1 = new Thread(new ThreadStart(CalNum));
            th1.Start();  
        }

        private void CalNum()
        {
            SetCalResult(DateTime.Now.Second);
        }

        //方法二：检查是否跨线程，然后将方法加入委托，调用委托  
        public delegate void SetTextHandler(int result);
        private void SetCalResult(int result)
        {
            if (label2.InvokeRequired == true)
            {
                SetTextHandler set = new SetTextHandler(SetCalResult);//委托的方法参数应和SetCalResult一致  
                label2.Invoke(set, new object[] { result }); //此方法第二参数用于传入方法,代替形参result  
            }
            else
            {
                label2.Text = result.ToString();
            }
        }
    }
}
